; Sa se scrie un program rezident care din timp in timp afiseaza data si ora 
; in coltul din stanga sus al ecranului pentru cateva secunde, dupa care reda controlul utilizatorului

cseg segment

	assume	cs:cseg

	ident 		db  "_IDENTIF_"
	lng			equ	$ - ident
	mes_inst 	db	"TSR instalat! Asteptati cateva secunde! $"
	mes_dezinst	db	"TSR dezinstalat ! $"

	
;  ----- Spatiu pentru memorat vectorul vechi de intrerupere ----

	old1C	label	dword
			old1C_off dw ?
			old1C_seg dw ?

	;spatiu pentru adresa flagului INDOS
	flag_dos label dword
			indos_off	dw	?
			indos_seg	dw	?
	
	flag_tsr 	db 0				;flag TSR activ (=1 se afiseaza ceasul, =0 nu se afiseaza ceasul)
		
	sp_tsr 		dw ? 				; stack pointer program TSR
	buff_video 	db 4000 dup (1)		; buffer salvare ecran
	dta			db 43 dup (?)		; DTA local TSR
	psp_tsr 	dw ?				; Adresa PSP a programului TSR
	dta_tsr		dd dta				; Adresa DTA a programului rezident
	
	
	vector 		db 7 dup (0)		; vector pentru a tine data si ora
	cnt 		dw 0				; counter pentru  timp
	delay 		dw 100				; delay intre activari


; noua rutina de tratare a intreruperii 1Ch
new1C	proc	far
		pushf
		call	dword ptr cs:old1C	; Apel rutina veche (programele TSR se dezvolta de obicei sub forma unui unic segment
									; adresabil prin registrul CS. Aceasta explica prezenta prefixului de segment din instr. call)
		
		push	ax					; salvari registre
		push	bx
		push	cx
		push	dx
	
		
		cmp	cs:flag_tsr, 0   	; test de TSR deja activ
		je	cs:notflag_tsr
		jmp	cs:new1C_end		;terminare procedura daca tsr-ul este ectiv
	
notflag_tsr:
		mov	ax, cs:delay		; seteaza delayul dintre activari
		cmp	cs:cnt, ax			;daca timpul de activare a trecut
		je enableClock			;activez ceasul
		inc	cs:cnt				;incrementez counterul
		jmp	new1C_end			;daca nu se termina procedura
	
enableClock:					;daca ceasul este inactiv atunci afiseaza-l
		mov	cs:flag_tsr, 1
		mov	cs:cnt, 0
		call displayON	
		call showClock
	
		mov	cx,0FFFFh
		
loopClock:						;cat timp afisez ceasul
		mov ax, cx
		mov	cx, 0FFFFh
		call showClock
		et1:
			loop et1
			mov	cx, ax	
			loop loopClock
	
disableClock:
		call displayOFF
		mov	 cs:flag_tsr, 0
		mov	 cs:cnt, 0
	
new1C_end:
		pop	dx
		pop	cx
		pop	bx
		pop	ax
		retf 2
new1C endp


; Procedura care afiseaza data si ora

showClock proc near

		push ax				;salvari registrii
		push bx
		push cx
		push dx
		push bp
		push es
			
		mov ah, 04h			;functia 04h a intreruperii 1Ah --> Read Real vector Clock Date
		int 1Ah				; intreruperea 1Ah --> get date
		mov vector[0], ch		; secolul --> Century (19 sau 20) (BCD)
		mov vector[1], cl		; anul --> Year (BCD)		
		mov vector[2], dh		; luna --> Month (BCD)
		mov vector[3], dl		; ziua --> Day (BCD)
		
		mov ah, 02h			; functia 02h a intreuperii 1Ah -->  Read Real vector Clock vector
		int 1Ah				; intreruperea 1Ah --> get vector
		mov vector[4], ch		; ora --> Hours (BCD)
		mov vector[5], cl		; minutele --> Minutes (BCD)
		mov vector[6], dh		; secundele --> Seconds (BCD)
	
		mov ax, 0B800h		; adresa ecran color
		mov es, ax
		mov bp, 0
	
		; pentru secol
		
		mov al, vector[0]
		shr al, 4			;prima cifra
		add al, 48
		mov es:bp, al
		inc bp
		mov es:bp, byte ptr 070h
	
		inc bp
		mov al, vector[0]
		and al, 15
		add al, 48			;a doua cifra
		mov es:bp, al
		inc bp
		mov es:bp, byte ptr 070h
	
		; pentru an
		
		mov al, vector[1]
		shr al, 4			;prima cifra
		add al, 48
		inc bp
		mov es:bp, al
		inc bp
		mov es:bp, byte ptr 070h
	
		inc bp
		mov al, vector[1]
		and al, 15
		add al, 48			;a doua cifra
		mov es:bp, al
		inc bp
		mov es:bp, byte ptr 070h
		
		;slash
		inc bp
		mov es:bp, byte ptr 2Fh
		inc bp
		mov es:bp, byte ptr 070h	
	
		; pentru luna
		
		inc bp
		mov al, vector[2]
		shr al, 4					;prima cifra
		add al, 48	
		mov es:bp, al
		inc bp
		mov es:bp, byte ptr 070h	
		
		mov al, vector[2]
		and al, 15	
		add al, 48					;a doua cifra
		inc bp
		mov es:bp, al
		inc bp
		mov es:bp, byte ptr 070h
		
		;slash
		inc bp
		mov es:bp, byte ptr 2Fh
		inc bp
		mov es:bp, byte ptr 070h	
	
		; pentru zi
		
		mov al, vector[3]
		shr al, 4					;prima cifra
		add al, 48
		inc bp
        mov es:bp, al
		inc bp
		mov es:bp, byte ptr 070h
	
		inc bp
		mov al, vector[3]
		and al, 15
		add al, 48					;a doua cifra
		mov es:bp, al
		inc bp
		mov es:bp, byte ptr 070h	

        ; 3 spatii
		inc bp
		mov es:bp, byte ptr 20h
		inc bp
		mov es:bp, byte ptr 070h	
		inc bp
		mov es:bp, byte ptr 20h
		inc bp
		mov es:bp, byte ptr 070h	
		inc bp
		mov es:bp, byte ptr 20h
		inc bp
		mov es:bp, byte ptr 070h	
		
		; pentru ora
		
		mov al, vector[4]
		shr al, 4					;prima cifra
		add al, 48
		inc bp
		mov es:bp, al
		inc bp
		mov es:bp, byte ptr 070h
	
		inc bp
		mov al, vector[4]
		and al, 15
		add al, 48					;a doua cifra
		mov es:bp, al
		inc bp
		mov es:bp, byte ptr 070h	
		
		; 2 puncte
		inc bp
		mov es:bp, byte ptr 3Ah
		inc bp
		mov es:bp, byte ptr 070h	
	
		; pentru minute
		mov al, vector[5]
		shr al, 4						;prima cifra
		add al, 48
		inc bp
		mov es:bp, al
		inc bp
		mov es:bp, byte ptr 070h
	
		inc bp
		mov al, vector[5]
		and al, 15
		add al, 48						;a doua cifra
		mov es:bp, al
		inc bp
		mov es:bp, byte ptr 070h	
		
		;2 puncte
		inc bp
		mov es:bp, byte ptr 3Ah
		inc bp
		mov es:bp, byte ptr 070h	
	
		; pentru secunde
		mov al, vector[6]
		shr al, 4						;prima cifra
		add al, 48
		inc bp
		mov es:bp, al
		inc bp
		mov es:bp, byte ptr 070h
	
		inc bp
		mov al, vector[6]
		and al, 15
		add al, 48						;a doua cifra
		mov es:bp, al
		inc bp
		mov es:bp, byte ptr 070h	
		
		pop es
		pop bp
		pop dx
		pop cx
		pop bx
		pop ax
		ret
showClock endp


; Procedura care salveaza continutul ecranului

displayON proc near	
		push es					;salvam regstrii
		push bp
		push ax
		push si
		
		;citim octeti din bufferul video
		mov ax,	0B800h			; adresa ecran color 
		mov es, ax				; destinatie = cs:buffer_video
		mov cx, 4000			; copiere 80*25*2 octeti
		
	nextdisplayON:	
		mov bp, cx
		mov si, cx
		mov al, es:bp			; in AL punem un byte de la adresa memoriei video
		mov buff_video[si], al	;copiem din AL in buff_video
		loop nextdisplayON
		
		mov bp, cx
		mov si, cx
		mov al, es:bp	
		mov buff_video[si], al	
		
		pop si
		pop ax
		pop bp
		pop es
		ret
displayON endp	


;Refacerea ecranul salvat in buff_video

displayOFF proc near	
		push es				;salvam registrii
		push bp
		push ax
		push si
		
		mov ax,	0B800h		;punem in es adresa memoriei video 
		mov es, ax	
		mov cx, 4000
		
nextdisplayOFF:	
		mov bp, cx
		mov si, cx
		mov al, buff_video[si]	;copiaza in al din buffer
		mov es:bp, al	
		loop nextdisplayOFF
		
		mov bp, cx
		mov si, cx
		mov al, buff_video[si]	
		mov es:bp, al	
		
		pop si
		pop ax
		pop bp
		pop es
		ret
		
displayOFF endp	


;Rutina urmatoare reface vectorii de intrerupere si elibereaza
;memoria alocata pentru programul TSR

dezinst	proc near
	
		; in ES : segmentul programului rezident
		
		push ds
		push es
		cli			;clear interrupt
	
		; Refacere vector de intrerupere 1Ch
		
		mov	ax, 251Ch
		mov	ds, es:old1C_seg
		mov	dx, es:old1C_off
		int	21h
	
		sti		;set interrupt
		
		; Prima data eliberam blocul de environment, a carui adresa 
		; de segment se gaseste la offsetul 2Ch in PSP
		
		mov	bx, es:psp_tsr
		mov	es, bx				; Adresa PSP
		mov	es, es:[2ch]		; ES = adresa bloc environment
		mov	ah, 49h				; Eliberare memorie alocata la instalare
		int	21h
	
		; Acum eliberam memoria detinuta de programul TSR, 
		; incepand de la PSP
		
		mov	es, bx		; ES = PSP-ul TSR-ului
		mov	ah, 49h		; Eliberare
		int	21h
	
		
		pop	es
		pop	ds
		ret	

dezinst	endp


sfarsit label byte		;eticheta pentru a pastra rezident numai pana aici


; Aici e punctul de start al programului

start:
		mov	ax, cseg		; Initializari registre de segment si stiva
		mov	ds, ax
		mov	ss, ax
		mov	sp, sp_tsr
	
		; Testam daca TSR-ul este deja instalat
		
		mov	ax, 351Ch	;functia DOS 35h a intreruperii INT 21h returneaza in ES:BX vechiul vector de intrerupere 
						;(obtine adresa handlerului de intrerupere) 
		int	21h			
		
		mov	ax, cs		; DS = segment program curent
		mov	ds, ax		
	
		xor	si, si		;offset-uri 0
		mov	di, si
		mov	cx, lng		; lungime mesaj
		repz cmpsb		;comparam ds:[si] cu es:[di]
		jnz	not_inst	;nu e instalat, salt
		
		
		call dezinst				; dezinstalare, apoi
		mov	dx, offset mes_dezinst	; mesaj dezinstalare
		mov	ah, 9					;functia print string a INT 21h 
		int	21h
		

		mov	ax, 4C00h 				; Iesire normala (terminare proces)
		int	21h
	
not_inst:
		
		mov	cnt, 0 			; initializare counter
		mov flag_tsr, 0		; not installed
	
		; Instalare TSR
		
		mov	ah, 62h			;citire PSP si salvare pentru comutare context la activari viitoare -- Get PSP Adress
		int	21h
		
		mov	psp_tsr, bx
	
		mov	ah, 1Ah			; Similar pt DTA
		lds	dx, dta_tsr
		int	21h
	
		;Citire si salvare vector vechi
		
		;(nivelul 1Ch)
		
		mov	ax, 351Ch
		int	21h
		mov	cs:old1C_off, bx
		mov	cs:old1C_seg, es
	
	
		mov	ax, cs
		mov	ds, ax
		
		push ds
		push es
	
		;Pozitionare vector nou
		
		mov	ax, 251Ch			
		mov	dx, offset new1C
		int	21h					; vector 1Ch nou
		
		;citire si salvare adresa flag INDOS
		mov	ax, 3400h
		int	21h
		mov	cs:indos_off, bx
		mov	cs:indos_seg, es
		
		pop	es
		pop	ds
	
		mov	ah, 09h
		lea	dx, mes_inst		; Mesaj instalare
		int	21h
	
		; Calcul al necesarului de memorie (inclusiv PSP-ul)
		
		mov	dx, offset sfarsit + 100h
		mov	cl, 4						;Spatiul se specifica in paragrafe de cate 16 octeti
		shr	dx, cl
		
		inc	dx
		mov	ax, 3100h		; Terminare cu ramanere in memorie
	
		int	21h
		
cseg ends
end	 start