using System;
using System.Collections.Generic;
using System.Text;

namespace modbus_CRC
{
    class Modbus
    {
        const int READ = 0x03;
        const int CHANGEADDRESS = 0x06;
        const int TEMPERATURE = 0x03;
        private byte[] stream = new byte[256];
        //byte[] stream = { 0x0A, 0x03, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00 };
        private short stream_length = 0;

        public void addAddress(uint address)
        // Adds the sensor's address 
        {
            // if we change the address don't increment the length
            if (stream[0] == 0x00)  stream_length++;
            stream[0] = (byte)address;
        }

        public void addOperation(string operation)
        // Tells the sensor what operation to perform  
        {
            if (stream[1] == 0x00)  stream_length++;
            switch (operation)
            {
                case "READ":
                    stream[1] = READ;
                    break;
                case "CHANGEADDRESS":
                    stream[1] = CHANGEADDRESS;
                    break;
            }
        }

        public void addData(byte[] data)
        // Add data to send to the sensor
        {
            for (int i=0; i<data.Length; i++)
                stream[2+i]=data[i];
            stream_length += (short) data.Length;     // the length
        }

        public byte[] getStream()
        //returns the byte stream that will be sent on the COMM port
        {
            return stream;
        }

        public int getStreamLength()
        {
            return stream_length;
        }
        public void CRC()
        // Accepts as input the byte array and appends the CRC
        {
            uint xor_constant = 0xA001;
            uint last_xor = 0xFFFF;

            for (int i = 0; i < stream_length ; i++)
            {
                last_xor = stream[i] ^ last_xor;
                for (int j = 0; j <= 7; j++)
                {
                    if (last_xor >> 1 << 1 != last_xor)
                    {
                        last_xor >>= 1;
                        last_xor ^= xor_constant;
                    }
                    else
                    {
                        last_xor = last_xor >> 1;
                    }
                }
            }
            //return last_xor;
            /*      append the CRC to the array     */
            stream[stream_length ] = Convert.ToByte(last_xor & 0x00FE);
            stream[stream_length + 1] = Convert.ToByte(last_xor >> 8);
            stream_length += 2;
        }
    }
}
